# oh-my-gadt

_Nikhil Mehta and Alexis Gadonneix_

A simple ML-like language implementing type inference for GADTs.

## Build

`stack build`

## Run

### Parse and print parse tree

`stack exec oh-my-gadt-exe -- -p < input-file`

### Parse, type check, and print type (if type checking succeeds)

`stack exec oh-my-gadt-exe -- -t < input-file`

### Parse, type check, evaluate and print result

`stack exec oh-my-gadt-exe -- -e < input-file`

## Test

```
cd test
./test.sh
```

See `test/tests.log` for a summary of the test results.
